Pipe.SourceChannel (Java Platform SE 8 )
Keywords: java.nio.channels.Pipe.SourceChannel class
Date: 2026-04-17

compact1, compact2, compact3
java.nio.channels

## Class Pipe.SourceChannel

- java.lang.Object
- - java.nio.channels.spi.AbstractInterruptibleChannel
  - - java.nio.channels.SelectableChannel
    - - java.nio.channels.spi.AbstractSelectableChannel
      - - java.nio.channels.Pipe.SourceChannel

- All Implemented Interfaces:
    Closeable, AutoCloseable, Channel, InterruptibleChannel, ReadableByteChannel, ScatteringByteChannel
  Enclosing class:
    Pipe

      public abstract static class Pipe.SourceChannel
      extends AbstractSelectableChannel
      implements ReadableByteChannel, ScatteringByteChannel

  A channel representing the readable end of a `Pipe`.
  Since:
    1.4

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SourceChannel(SelectorProvider provider)` Constructs a new instance of this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `validOps()` Returns an operation set identifying this channel's supported operations.

    - ### Methods inherited from class java.nio.channels.spi.AbstractSelectableChannel

      `blockingLock, configureBlocking, implCloseChannel, implCloseSelectableChannel, implConfigureBlocking, isBlocking, isRegistered, keyFor, provider, register`

    - ### Methods inherited from class java.nio.channels.SelectableChannel

      `register`

    - ### Methods inherited from class java.nio.channels.spi.AbstractInterruptibleChannel

      `begin, close, end, isOpen`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.nio.channels.ScatteringByteChannel

      `read, read`

    - ### Methods inherited from interface java.nio.channels.ReadableByteChannel

      `read`

    - ### Methods inherited from interface java.nio.channels.Channel

      `close, isOpen`

- - ### Constructor Detail

    - #### SourceChannel

          protected SourceChannel(SelectorProvider provider)

      Constructs a new instance of this class.
      Parameters:
        `provider` - The selector provider

  - ### Method Detail

    - #### validOps

          public final int validOps()

      Returns an operation set identifying this channel's supported operations.

      Pipe-source channels only support reading, so this method returns `SelectionKey.OP_READ`.

      Specified by:
        `validOps` in class `SelectableChannel`
      Returns:
        The valid-operation set

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.